=== modified file 'TODO'
--- TODO	2010-08-22 13:34:42 +0000
+++ TODO	2010-03-27 18:39:02 +0000
@@ -1,7 +1,5 @@
 -*- org -*-
 
-* _attribute_((nonnull))
-
 * mandos-client
 ** TODO [#B] use scandir(3) instead of readdir(3)
 ** TODO [#B] Prefix all debug output with "Mandos plugin " + program_invocation_short_name
@@ -40,8 +38,6 @@
 ** TODO [#C] use same file name rules as run-parts(8)
 ** kernel command line option for debug info
 ** TODO [#B] use error() instead of perror()
-** TODO [$B] Use openat() and readdir64()
-   http://udrepper.livejournal.com/19395.html
 
 * mandos (server)
 ** TODO [#B] Log level							  :BUGS:
@@ -72,19 +68,6 @@
    A client needs manual approval on the server before it gets the
    secret
 ** TODO [#B] Support RFC 3339 time duration syntax
-** More D-Bus methods
-*** NeedsApproval(50, True) -> timeout, default approve
-    Default approval is configurable, but True by default
-    + Approval(True) -> approve sending saved
-    + Approval(False) -> Close client connection immediately
-*** NeedsPassword(50) - Timeout, default disapprove
-    + SetPass(u"gazonk", True) -> Approval, persistent
-    + Approval(False) -> Close client connection immediately
-** TODO [#C] python-parsedatetime
-** TODO [#C] systemd/launchd
-   http://0pointer.de/blog/projects/systemd.html
-** TODO Separate logging logic to own object
-** TODO make clients to a dict!
 
 * mandos.xml
 ** [[file:mandos.xml::XXX][Document D-Bus interface]]
@@ -115,8 +98,6 @@
    For testing decryption before rebooting.
 
 * Makefile
-** TODO Add "--Xlinker --as-needed"
-   http://udrepper.livejournal.com/19395.html
 ** TODO [#C] Implement DEB_BUILD_OPTIONS
    http://www.debian.org/doc/debian-policy/ch-source.html#s-debianrules-options
 
@@ -128,9 +109,5 @@
 ** TODO [#C] /etc/bash_completion.d/mandos
    From XML sources directly?
 
-* Side Stuff
-** TODO Locate which packet move the other bin/sh when busy box is deactivated
-** TODO contact owner of packet, and ask them to have that shell static in position regardless of busybox
-
 
 #+STARTUP: showall

=== modified file 'debian/control'
--- debian/control	2010-08-23 19:23:15 +0000
+++ debian/control	2010-01-01 15:17:12 +0000
@@ -15,8 +15,7 @@
 Package: mandos
 Architecture: all
 Depends: ${misc:Depends}, python (>=2.5), python-gnutls, python-dbus,
-	python-avahi, python-gobject, avahi-daemon, adduser,
-	python-urwid
+	python-avahi, python-gobject, avahi-daemon, adduser
 Recommends: fping
 Description: a server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== modified file 'mandos'
--- mandos	2010-08-24 18:18:01 +0000
+++ mandos	2009-12-25 23:13:47 +0000
@@ -60,7 +60,6 @@
 import fcntl
 import functools
 import cPickle as pickle
-import multiprocessing
 
 import dbus
 import dbus.service
@@ -83,7 +82,7 @@
 
 version = "1.0.14"
 
-logger = logging.getLogger(u'mandos')
+logger = logging.Logger(u'mandos')
 syslogger = (logging.handlers.SysLogHandler
              (facility = logging.handlers.SysLogHandler.LOG_DAEMON,
               address = "/dev/log"))
@@ -98,8 +97,6 @@
                                        u' %(message)s'))
 logger.addHandler(console)
 
-multiprocessing_manager = multiprocessing.Manager()
-
 class AvahiError(Exception):
     def __init__(self, value, *args, **kwargs):
         self.value = value
@@ -260,9 +257,6 @@
                      runtime with vars(self) as dict, so that for
                      instance %(name)s can be used in the command.
     current_checker_command: string; current running checker_command
-    approved_delay: datetime.timedelta(); Time to wait for approval
-    _approved:   bool(); 'None' if not yet approved/disapproved
-    approved_duration: datetime.timedelta(); Duration of one approval
     """
     
     @staticmethod
@@ -279,9 +273,6 @@
     def interval_milliseconds(self):
         "Return the 'interval' attribute in milliseconds"
         return self._timedelta_to_milliseconds(self.interval)
-
-    def approved_delay_milliseconds(self):
-        return self._timedelta_to_milliseconds(self.approved_delay)
     
     def __init__(self, name = None, disable_hook=None, config=None):
         """Note: the 'checker' key in 'config' sets the
@@ -305,7 +296,6 @@
                       "rb") as secfile:
                 self.secret = secfile.read()
         else:
-            #XXX Need to allow secret on demand!
             raise TypeError(u"No secret or secfile for client %s"
                             % self.name)
         self.host = config.get(u"host", u"")
@@ -323,27 +313,12 @@
         self.checker_command = config[u"checker"]
         self.current_checker_command = None
         self.last_connect = None
-        self.approvals_pending = 0
-        self._approved = None
-        self.approved_by_default = config.get(u"approved_by_default",
-                                              True)
-        self.approved_delay = string_to_delta(
-            config[u"approved_delay"])
-        self.approved_duration = string_to_delta(
-            config[u"approved_duration"])
-        self.changedstate = multiprocessing_manager.Condition(multiprocessing_manager.Lock())
-
-    def send_changedstate(self):
-        self.changedstate.acquire()
-        self.changedstate.notify_all()
-        self.changedstate.release()
-        
+    
     def enable(self):
         """Start this client's checker and timeout hooks"""
         if getattr(self, u"enabled", False):
             # Already enabled
             return
-        self.send_changedstate()
         self.last_enabled = datetime.datetime.utcnow()
         # Schedule a new checker to be started an 'interval' from now,
         # and every interval from then on.
@@ -363,8 +338,6 @@
         if not getattr(self, "enabled", False):
             return False
         if not quiet:
-            self.send_changedstate()
-        if not quiet:
             logger.info(u"Disabling client %s", self.name)
         if getattr(self, u"disable_initiator_tag", False):
             gobject.source_remove(self.disable_initiator_tag)
@@ -503,6 +476,7 @@
                 raise
         self.checker = None
 
+
 def dbus_service_property(dbus_interface, signature=u"v",
                           access=u"readwrite", byte_arrays=False):
     """Decorators for marking methods of a DBusObjectWithProperties to
@@ -805,23 +779,14 @@
             self.PropertyChanged(dbus.String(u"checker_running"),
                                  dbus.Boolean(False, variant_level=1))
         return r
-
-    def _reset_approved(self):
-        self._approved = None
-        return False
-    
-    def approve(self, value=True):
-        self._approved = value
-        gobject.timeout_add(self._timedelta_to_milliseconds(self.approved_duration, self._reset_approved))
-
-    def approved_pending(self):
-        return self.approvals_pending > 0
-    
-    
-    ## D-Bus methods, signals & properties
+    
+    ## D-Bus methods & signals
     _interface = u"se.bsnet.fukt.Mandos.Client"
     
-    ## Signals
+    # CheckedOK - method
+    @dbus.service.method(_interface)
+    def CheckedOK(self):
+        return self.checked_ok()
     
     # CheckerCompleted - signal
     @dbus.service.signal(_interface, signature=u"nxs")
@@ -845,37 +810,13 @@
     @dbus.service.signal(_interface)
     def GotSecret(self):
         "D-Bus signal"
-        if self.approved_pending():
-            self.PropertyChanged(dbus.String(u"checker_running"),
-                                 dbus.Boolean(False, variant_level=1))
+        pass
     
     # Rejected - signal
-    @dbus.service.signal(_interface, signature=u"s")
-    def Rejected(self, reason):
-        "D-Bus signal"
-        if self.approved_pending():
-            self.PropertyChanged(dbus.String(u"checker_running"),
-                                 dbus.Boolean(False, variant_level=1))
-    
-    # NeedApproval - signal
-    @dbus.service.signal(_interface, signature=u"db")
-    def NeedApproval(self, timeout, default):
-        "D-Bus signal"
-        if not self.approved_pending():
-            self.PropertyChanged(dbus.String(u"approved_pending"),
-                                 dbus.Boolean(True, variant_level=1))
-    
-    ## Methods
-
-    # Approve - method
-    @dbus.service.method(_interface, in_signature=u"b")
-    def Approve(self, value):
-        self.approve(value)
-
-    # CheckedOK - method
-    @dbus.service.method(_interface)
-    def CheckedOK(self):
-        return self.checked_ok()
+    @dbus.service.signal(_interface)
+    def Rejected(self):
+        "D-Bus signal"
+        pass
     
     # Enable - method
     @dbus.service.method(_interface)
@@ -900,32 +841,6 @@
     def StopChecker(self):
         self.stop_checker()
     
-    ## Properties
-    
-    # approved_pending - property
-    @dbus_service_property(_interface, signature=u"b", access=u"read")
-    def approved_pending_dbus_property(self):
-        return dbus.Boolean(self.approved_pending())
-    
-    # approved_by_default - property
-    @dbus_service_property(_interface, signature=u"b",
-                           access=u"readwrite")
-    def approved_by_default_dbus_property(self):
-        return dbus.Boolean(self.approved_by_default)
-    
-    # approved_delay - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
-    def approved_delay_dbus_property(self):
-        return dbus.UInt64(self.approved_delay_milliseconds())
-    
-    # approved_duration - property
-    @dbus_service_property(_interface, signature=u"t",
-                           access=u"readwrite")
-    def approved_duration_dbus_property(self):
-        return dbus.UInt64(self._timedelta_to_milliseconds(
-                self.approved_duration))
-    
     # name - property
     @dbus_service_property(_interface, signature=u"s", access=u"read")
     def name_dbus_property(self):
@@ -1065,32 +980,6 @@
     del _interface
 
 
-class ProxyClient(object):
-    def __init__(self, child_pipe, fpr, address):
-        self._pipe = child_pipe
-        self._pipe.send(('init', fpr, address))
-        if not self._pipe.recv():
-            raise KeyError()
-
-    def __getattribute__(self, name):
-        if(name == '_pipe'):
-            return super(ProxyClient, self).__getattribute__(name)
-        self._pipe.send(('getattr', name))
-        data = self._pipe.recv()
-        if data[0] == 'data':
-            return data[1]
-        if data[0] == 'function':
-            def func(*args, **kwargs):
-                self._pipe.send(('funcall', name, args, kwargs))
-                return self._pipe.recv()[1]
-            return func
-
-    def __setattr__(self, name, value):
-        if(name == '_pipe'):
-            return super(ProxyClient, self).__setattr__(name, value)
-        self._pipe.send(('setattr', name, value))
-
-
 class ClientHandler(socketserver.BaseRequestHandler, object):
     """A class to handle client connections.
     
@@ -1098,22 +987,34 @@
     Note: This will run in its own forked process."""
     
     def handle(self):
-        with contextlib.closing(self.server.child_pipe) as child_pipe:
-            logger.info(u"TCP connection from: %s",
-                        unicode(self.client_address))
-            logger.debug(u"Pipe FD: %d",
-                         self.server.child_pipe.fileno())
-
+        logger.info(u"TCP connection from: %s",
+                    unicode(self.client_address))
+        logger.debug(u"IPC Pipe FD: %d", self.server.child_pipe[1])
+        # Open IPC pipe to parent process
+        with contextlib.nested(os.fdopen(self.server.child_pipe[1],
+                                         u"w", 1),
+                               os.fdopen(self.server.parent_pipe[0],
+                                         u"r", 0)) as (ipc,
+                                                       ipc_return):
             session = (gnutls.connection
                        .ClientSession(self.request,
                                       gnutls.connection
                                       .X509Credentials()))
-
+            
+            line = self.request.makefile().readline()
+            logger.debug(u"Protocol version: %r", line)
+            try:
+                if int(line.strip().split()[0]) > 1:
+                    raise RuntimeError
+            except (ValueError, IndexError, RuntimeError), error:
+                logger.error(u"Unknown protocol version: %s", error)
+                return
+            
             # Note: gnutls.connection.X509Credentials is really a
             # generic GnuTLS certificate credentials object so long as
             # no X.509 keys are added to it.  Therefore, we can use it
             # here despite using OpenPGP certificates.
-
+            
             #priority = u':'.join((u"NONE", u"+VERS-TLS1.1",
             #                      u"+AES-256-CBC", u"+SHA1",
             #                      u"+COMP-NULL", u"+CTYPE-OPENPGP",
@@ -1125,19 +1026,7 @@
             (gnutls.library.functions
              .gnutls_priority_set_direct(session._c_object,
                                          priority, None))
-
-            # Start communication using the Mandos protocol
-            # Get protocol number
-            line = self.request.makefile().readline()
-            logger.debug(u"Protocol version: %r", line)
-            try:
-                if int(line.strip().split()[0]) > 1:
-                    raise RuntimeError
-            except (ValueError, IndexError, RuntimeError), error:
-                logger.error(u"Unknown protocol version: %s", error)
-                return
-
-            # Start GnuTLS connection
+            
             try:
                 session.handshake()
             except gnutls.errors.GNUTLSError, error:
@@ -1146,8 +1035,6 @@
                 # established.  Just abandon the request.
                 return
             logger.debug(u"Handshake succeeded")
-
-            approval_required = False
             try:
                 try:
                     fpr = self.fingerprint(self.peer_certificate
@@ -1157,85 +1044,31 @@
                     return
                 logger.debug(u"Fingerprint: %s", fpr)
 
-                try:
-                    client = ProxyClient(child_pipe, fpr,
-                                         self.client_address)
-                except KeyError:
-                    return
-                
-                if client.approved_delay:
-                    delay = client.approved_delay
-                    client.approvals_pending += 1
-                    approval_required = True
-                
-                while True:
-                    if not client.enabled:
-                        logger.warning(u"Client %s is disabled",
-                                       client.name)
-                        if self.server.use_dbus:
-                            # Emit D-Bus signal
-                            client.Rejected("Disabled")                    
-                        return
-                    
-                    if client._approved or not client.approved_delay:
-                        #We are approved or approval is disabled
+                for c in self.server.clients:
+                    if c.fingerprint == fpr:
+                        client = c
                         break
-                    elif client._approved is None:
-                        logger.info(u"Client %s need approval",
-                                    client.name)
-                        if self.server.use_dbus:
-                            # Emit D-Bus signal
-                            client.NeedApproval(
-                                client.approved_delay_milliseconds(),
-                                client.approved_by_default)
-                    else:
-                        logger.warning(u"Client %s was not approved",
-                                       client.name)
-                        if self.server.use_dbus:
-                            # Emit D-Bus signal
-                            client.Rejected("Disapproved")
-                        return
-                    
-                    #wait until timeout or approved
-                    #x = float(client._timedelta_to_milliseconds(delay))
-                    time = datetime.datetime.now()
-                    client.changedstate.acquire()
-                    client.changedstate.wait(float(client._timedelta_to_milliseconds(delay) / 1000))
-                    client.changedstate.release()
-                    time2 = datetime.datetime.now()
-                    if (time2 - time) >= delay:
-                        if not client.approved_by_default:
-                            logger.warning("Client %s timed out while"
-                                           " waiting for approval",
-                                           client.name)
-                            if self.server.use_dbus:
-                                # Emit D-Bus signal
-                                client.Rejected("Time out")
-                            return
-                        else:
-                            break
-                    else:
-                        delay -= time2 - time
-                
+                else:
+                    ipc.write(u"NOTFOUND %s %s\n"
+                              % (fpr, unicode(self.client_address)))
+                    return
+                # Have to check if client.enabled, since it is
+                # possible that the client was disabled since the
+                # GnuTLS session was established.
+                ipc.write(u"GETATTR enabled %s\n" % fpr)
+                enabled = pickle.load(ipc_return)
+                if not enabled:
+                    ipc.write(u"DISABLED %s\n" % client.name)
+                    return
+                ipc.write(u"SENDING %s\n" % client.name)
                 sent_size = 0
                 while sent_size < len(client.secret):
-                    # XXX handle session exception
                     sent = session.send(client.secret[sent_size:])
                     logger.debug(u"Sent: %d, remaining: %d",
                                  sent, len(client.secret)
                                  - (sent_size + sent))
                     sent_size += sent
-
-                logger.info(u"Sending secret to %s", client.name)
-                # bump the timeout as if seen
-                client.checked_ok()
-                if self.server.use_dbus:
-                    # Emit D-Bus signal
-                    client.GotSecret()
-            
             finally:
-                if approval_required:
-                    client.approvals_pending -= 1
                 session.bye()
     
     @staticmethod
@@ -1302,37 +1135,28 @@
         return hex_fpr
 
 
-class MultiprocessingMixIn(object):
-    """Like socketserver.ThreadingMixIn, but with multiprocessing"""
-    def sub_process_main(self, request, address):
-        try:
-            self.finish_request(request, address)
-        except:
-            self.handle_error(request, address)
-        self.close_request(request)
-            
-    def process_request(self, request, address):
-        """Start a new process to process the request."""
-        multiprocessing.Process(target = self.sub_process_main,
-                                args = (request, address)).start()
-
-class MultiprocessingMixInWithPipe(MultiprocessingMixIn, object):
-    """ adds a pipe to the MixIn """
+class ForkingMixInWithPipes(socketserver.ForkingMixIn, object):
+    """Like socketserver.ForkingMixIn, but also pass a pipe pair."""
     def process_request(self, request, client_address):
         """Overrides and wraps the original process_request().
         
         This function creates a new pipe in self.pipe
         """
-        parent_pipe, self.child_pipe = multiprocessing.Pipe()
-
-        super(MultiprocessingMixInWithPipe,
+        self.child_pipe = os.pipe() # Child writes here
+        self.parent_pipe = os.pipe() # Parent writes here
+        super(ForkingMixInWithPipes,
               self).process_request(request, client_address)
-        self.add_pipe(parent_pipe)
-    def add_pipe(self, parent_pipe):
+        # Close unused ends for parent
+        os.close(self.parent_pipe[0]) # close read end
+        os.close(self.child_pipe[1])  # close write end
+        self.add_pipe_fds(self.child_pipe[0], self.parent_pipe[1])
+    def add_pipe_fds(self, child_pipe_fd, parent_pipe_fd):
         """Dummy function; override as necessary"""
-        pass
-
-class IPv6_TCPServer(MultiprocessingMixInWithPipe,
+        os.close(child_pipe_fd)
+        os.close(parent_pipe_fd)
+
+
+class IPv6_TCPServer(ForkingMixInWithPipes,
                      socketserver.TCPServer, object):
     """IPv6-capable TCP server.  Accepts 'None' as address and/or port
     
@@ -1423,15 +1247,15 @@
             return socketserver.TCPServer.server_activate(self)
     def enable(self):
         self.enabled = True
-    def add_pipe(self, parent_pipe):
+    def add_pipe_fds(self, child_pipe_fd, parent_pipe_fd):
         # Call "handle_ipc" for both data and EOF events
-        gobject.io_add_watch(parent_pipe.fileno(),
+        gobject.io_add_watch(child_pipe_fd,
                              gobject.IO_IN | gobject.IO_HUP,
                              functools.partial(self.handle_ipc,
-                                               parent_pipe = parent_pipe))
-        
-    def handle_ipc(self, source, condition, parent_pipe=None,
-                   client_object=None):
+                                               reply_fd
+                                               =parent_pipe_fd))
+    def handle_ipc(self, source, condition, reply_fd=None,
+                   file_objects={}):
         condition_names = {
             gobject.IO_IN: u"IN",   # There is data to read.
             gobject.IO_OUT: u"OUT", # Data can be written (without
@@ -1449,54 +1273,75 @@
         logger.debug(u"Handling IPC: FD = %d, condition = %s", source,
                      conditions_string)
         
-        # Read a request from the child
-        request = parent_pipe.recv()
-        command = request[0]
+        # Turn the pipe file descriptors into Python file objects
+        if source not in file_objects:
+            file_objects[source] = os.fdopen(source, u"r", 1)
+        if reply_fd not in file_objects:
+            file_objects[reply_fd] = os.fdopen(reply_fd, u"w", 0)
         
-        if command == 'init':
-            fpr = request[1]
-            address = request[2]
-            
-            for c in self.clients:
-                if c.fingerprint == fpr:
-                    client = c
-                    break
-            else:
-                logger.warning(u"Client not found for fingerprint: %s, ad"
-                               u"dress: %s", fpr, address)
-                if self.use_dbus:
-                    # Emit D-Bus signal
-                    mandos_dbus_service.ClientNotFound(fpr, address)
-                parent_pipe.send(False)
-                return False
-            
-            gobject.io_add_watch(parent_pipe.fileno(),
-                                 gobject.IO_IN | gobject.IO_HUP,
-                                 functools.partial(self.handle_ipc,
-                                                   parent_pipe = parent_pipe,
-                                                   client_object = client))
-            parent_pipe.send(True)
-            # remove the old hook in favor of the new above hook on same fileno
+        # Read a line from the file object
+        cmdline = file_objects[source].readline()
+        if not cmdline:             # Empty line means end of file
+            # close the IPC pipes
+            file_objects[source].close()
+            del file_objects[source]
+            file_objects[reply_fd].close()
+            del file_objects[reply_fd]
+            
+            # Stop calling this function
             return False
-        if command == 'funcall':
-            funcname = request[1]
-            args = request[2]
-            kwargs = request[3]
-            
-            parent_pipe.send(('data', getattr(client_object, funcname)(*args, **kwargs)))
-
-        if command == 'getattr':
-            attrname = request[1]
-            if callable(client_object.__getattribute__(attrname)):
-                parent_pipe.send(('function',))
-            else:
-                parent_pipe.send(('data', client_object.__getattribute__(attrname)))
-
-        if command == 'setattr':
-            attrname = request[1]
-            value = request[2]
-            setattr(client_object, attrname, value)
-            
+        
+        logger.debug(u"IPC command: %r", cmdline)
+        
+        # Parse and act on command
+        cmd, args = cmdline.rstrip(u"\r\n").split(None, 1)
+        
+        if cmd == u"NOTFOUND":
+            fpr, address = args.split(None, 1)
+            logger.warning(u"Client not found for fingerprint: %s, ad"
+                           u"dress: %s", fpr, address)
+            if self.use_dbus:
+                # Emit D-Bus signal
+                mandos_dbus_service.ClientNotFound(fpr, address)
+        elif cmd == u"DISABLED":
+            for client in self.clients:
+                if client.name == args:
+                    logger.warning(u"Client %s is disabled", args)
+                    if self.use_dbus:
+                        # Emit D-Bus signal
+                        client.Rejected()
+                    break
+            else:
+                logger.error(u"Unknown client %s is disabled", args)
+        elif cmd == u"SENDING":
+            for client in self.clients:
+                if client.name == args:
+                    logger.info(u"Sending secret to %s", client.name)
+                    client.checked_ok()
+                    if self.use_dbus:
+                        # Emit D-Bus signal
+                        client.GotSecret()
+                    break
+            else:
+                logger.error(u"Sending secret to unknown client %s",
+                             args)
+        elif cmd == u"GETATTR":
+            attr_name, fpr = args.split(None, 1)
+            for client in self.clients:
+                if client.fingerprint == fpr:
+                    attr_value = getattr(client, attr_name, None)
+                    logger.debug("IPC reply: %r", attr_value)
+                    pickle.dump(attr_value, file_objects[reply_fd])
+                    break
+            else:
+                logger.error(u"Client %s on address %s requesting "
+                             u"attribute %s not found", fpr, address,
+                             attr_name)
+                pickle.dump(None, file_objects[reply_fd])
+        else:
+            logger.error(u"Unknown IPC command: %r", cmdline)
+        
+        # Keep calling this function
         return True
 
 
@@ -1690,8 +1535,6 @@
                         u"interval": u"5m",
                         u"checker": u"fping -q -- %%(host)s",
                         u"host": u"",
-                        u"approved_delay": u"0s",
-                        u"approved_duration": u"1s",
                         }
     client_config = configparser.SafeConfigParser(client_defaults)
     client_config.read(os.path.join(server_settings[u"configdir"],
@@ -1774,22 +1617,9 @@
     client_class = Client
     if use_dbus:
         client_class = functools.partial(ClientDBus, bus = bus)
-    def client_config_items(config, section):
-        special_settings = {
-            "approved_by_default":
-                lambda: config.getboolean(section,
-                                          "approved_by_default"),
-            }
-        for name, value in config.items(section):
-            try:
-                yield (name, special_settings[name]())
-            except KeyError:
-                yield (name, value)
-    
     tcp_server.clients.update(set(
             client_class(name = section,
-                         config= dict(client_config_items(
-                        client_config, section)))
+                         config= dict(client_config.items(section)))
             for section in client_config.sections()))
     if not tcp_server.clients:
         logger.warning(u"No clients defined")

=== modified file 'mandos-monitor'
--- mandos-monitor	2010-08-31 18:22:25 +0000
+++ mandos-monitor	2009-12-25 23:13:47 +0000
@@ -23,14 +23,11 @@
 
 locale.setlocale(locale.LC_ALL, u'')
 
-import logging
-logging.getLogger('dbus.proxies').setLevel(logging.CRITICAL)
-
 # Some useful constants
 domain = 'se.bsnet.fukt'
 server_interface = domain + '.Mandos'
 client_interface = domain + '.Mandos.Client'
-version = "1.0.15"
+version = "1.0.14"
 
 # Always run in monochrome mode
 urwid.curses_display.curses.has_colors = lambda : False
@@ -53,7 +50,7 @@
                                      self.property_changed,
                                      client_interface,
                                      byte_arrays=True)
-        
+
         self.properties.update(
             self.proxy.GetAll(client_interface,
                               dbus_interface = dbus.PROPERTIES_IFACE))
@@ -104,10 +101,6 @@
                                      self.got_secret,
                                      client_interface,
                                      byte_arrays=True)
-        self.proxy.connect_to_signal(u"NeedApproval",
-                                     self.need_approval,
-                                     client_interface,
-                                     byte_arrays=True)
         self.proxy.connect_to_signal(u"Rejected",
                                      self.rejected,
                                      client_interface,
@@ -115,9 +108,9 @@
     
     def checker_completed(self, exitstatus, condition, command):
         if exitstatus == 0:
-            #self.logger(u'Checker for client %s (command "%s")'
-            #            u' was successful'
-            #            % (self.properties[u"name"], command))
+            self.logger(u'Checker for client %s (command "%s")'
+                        u' was successful'
+                        % (self.properties[u"name"], command))
             return
         if os.WIFEXITED(condition):
             self.logger(u'Checker for client %s (command "%s")'
@@ -138,25 +131,16 @@
         self.logger(u'Checker for client %s completed mysteriously')
     
     def checker_started(self, command):
-        #self.logger(u'Client %s started checker "%s"'
-        #            % (self.properties[u"name"], unicode(command)))
-        pass
+        self.logger(u'Client %s started checker "%s"'
+                    % (self.properties[u"name"], unicode(command)))
     
     def got_secret(self):
         self.logger(u'Client %s received its secret'
                     % self.properties[u"name"])
     
-    def need_approval(self, timeout, default):
-        if not default:
-            message = u'Client %s needs approval within %s seconds'
-        else:
-            message = u'Client %s will get its secret in %s seconds'
-        self.logger(message
-                    % (self.properties[u"name"], timeout/1000))
-    
-    def rejected(self, reason):
-        self.logger(u'Client %s was rejected; reason: %s'
-                    % (self.properties[u"name"], reason))
+    def rejected(self):
+        self.logger(u'Client %s was rejected'
+                    % self.properties[u"name"])
     
     def selectable(self):
         """Make this a "selectable" widget.
@@ -241,10 +225,6 @@
 #             self.proxy.unpause()
 #         elif key == u"RET":
 #             self.open()
-        elif key == u"+":
-            self.proxy.Approve(True)
-        elif key == u"-":
-            self.proxy.Approve(False)
         else:
             return key
     

=== modified file 'plugins.d/usplash.c'
--- plugins.d/usplash.c	2010-05-18 16:56:54 +0000
+++ plugins.d/usplash.c	2010-03-27 18:39:02 +0000
@@ -607,10 +607,6 @@
     
     setsid();
     ret = chdir("/");
-    if(ret == -1){
-      perror("chdir");
-      _exit(EX_OSERR);
-    }
 /*     if(fork() != 0){ */
 /*       _exit(EXIT_SUCCESS); */
 /*     } */

